package symp.stardust;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class StardustUtil {
	public static String toString(Map<String,Object> structuredData ) {
		return toString( structuredData, 0 );
	}
	
	@SuppressWarnings({ "rawtypes" })
	static String toString(Object o, int level) {
		StringBuilder sb = new StringBuilder();
		String pad = pad(level);
		if (o instanceof Map) {
			Map map = (Map) o;
			Set entrySet = map.entrySet();
			for (Object oe : entrySet) {
				Map.Entry e = (Map.Entry) oe;
				Object v = e.getValue();
				sb.append( String.format( "%s%s=%s\n", pad, e.getKey(), v) );
				if (isContainer(v))
					sb.append( toString(v, level + 1) );
			}
		} else if (o instanceof List) {
			List l = (List) o;

			for (int i = 0; i < l.size(); ++i) {
				Object v = l.get(i);
				sb.append( String.format( "%s%d: %s\n", pad, i, v) );
				if (isContainer(v))
					sb.append( toString(v, level + 1) );
			}
		} else {
			sb.append( String.format( "Object: %s%s\n", pad, o) );
		}
		return sb.toString();
	}

	static boolean isContainer(Object v) {
		return v instanceof List || v instanceof Map;
	}

	static String pad(int level) {
		char[] c = new char[level * 3];
		Arrays.fill(c, ' ');
		return new String(c);
	}

}
